unit mystrings;

{$mode objfpc}{$H+}

interface

uses
	LazUTF8,
	ArrayList;

function Split(Input, Delimiter: String; Limit: Integer = -1): TStringsArray;

implementation

function Split(Input, Delimiter: String; Limit: Integer): TStringsArray;
var
	DelimiterFound, LimitExceeded: Boolean;
	CurrentPosition, DelimiterPosition: SizeInt;
	InputLength, DelimiterLength, Count: SizeInt;
	LastCharacterPosition: SizeInt absolute InputLength;
begin
	Result.Clear;

	CurrentPosition:= 1;
	InputLength:= UTF8Length(Input);
	DelimiterLength:= UTF8Length(Delimiter);

	while (CurrentPosition <= LastCharacterPosition) do begin
		DelimiterPosition:= UTF8Pos(Delimiter, Input, CurrentPosition);
		DelimiterFound:= DelimiterPosition <> 0;
		LimitExceeded:= (Limit <> -1) and (Result.Count >= Limit);

		if DelimiterFound and not LimitExceeded then
			Count:= DelimiterPosition - CurrentPosition
		else
			Count:= (InputLength - CurrentPosition) + 1;

		Result.Add(UTF8Copy(Input, CurrentPosition, Count));

		CurrentPosition += Count + DelimiterLength;
	end;
end;

end.

